unit Mr915APIV20;

interface
uses
  Windows;
// main header file for the Mr915ApiV2 DLL

// ************* APIϢ궨 *****************************//
  Const FUCCESS_COMMAND	 =	2000;	// ͳɹ
  Const FUCCESS_RETURN	 =	2001;	// ɹ

  Const ERR_NOTAG_RETURN   =2002;	//ûбǩ
  Const ERR_HANDLE_VALUE   =2003;	//Ķ˿ھ
  Const ERR_UDATA_LEN      =2004;	//ָݳȴ
  Const ERR_UDATA_ADDRESS  =2006;	//ָݵַ
  Const ERR_RDATA_LEN      =2007;	//ݳȲ
  Const ERR_SDATA_FAIL     =2008;	//ݸʽ
  Const ERR_SCMND_FAIL     =2009;	//ʧ
  Const ERR_READ_FAIL      =2010;	//ǩʧ
  Const ERR_WRITE_FAIL     =2011;	//дǩʧ
  Const ERR_LOCK_FAIL      =2012;	//ǩʧ
  Const ERR_EREASE_FAIL    =2013;	//ǩɾʧ
  Const ERR_PORT_OPENED    =2014;	//עʧ
  Const ERR_OPEN_REGSTER   =2015;	//˿Ѿ򿪣INVALID_HANDLE_VALUE
  Const ERR_LOAD_INI_LOST  =2016;	//ϢΪҵȡʧܣҪ޷ʼ
  Const ERR_DEV_INIT_FAIL  =2017;	//豸ʼʧ
  Const ERR_PORT_OPEN_FAIL =2018;	//򿪶˿ʧ
  Const ERR_PORT_CLOSE_FAIL=2019;	//رն˿ʧ

  Const ERR_OUT_PARA_LEN	  = 2020; //ݳȳ
  Const ERR_GET_PARA_FAIL	  =	2021; //ѯ豸ʧ
  Const ERR_SET_PARA_FAIL	  =	2022; //趨豸ʧ
  Const RDERR_ GENERAL_ERR	=	2101; // ͳĴ
  Const RDERR_PAR_SET_FAILED=	2102; // ʧ
  Const RDERR_PAR_GET_FAILED=	2103; // ȡʧ
  Const RDERR_NO_TAG        =	2104; // ޱǩ
  Const RDERR_READ_FAILED	  =	2105;	// ǩʧ
  Const RDERR_WRITE_FAILED  = 2106;	// ǩдʧ
  Const RDERR_LOCK_FAILED	  =	2107;	// ǩʧ
  Const RDERR_ERASE_FAILED  = 2108;	// ǩʧ
  Const RDERR_CMD_ERR	      =	2354;	// ֻ֧Χ
  Const RDERR_UNDEFINED	    =	2355;	// δ
  Const ERR_OTHER_FAIL	=	3000;	  // ʧ
/////////////////////////////////////////////////////////////////////////////
  Const ISO6BLabel  = 1;          // ISO18000-6Bǩ
  Const EPCG2Label  = 2;          // ISO18000-6C(EPC C1 G2)ǩ
  Const CONTINUE_TIMES = 999999;  // 

  Const PARAM_INDICATE = 1;	  //	ʶʾ
  Const PARAM_READER_ADDR	= 2;	//	дַ-RS485ͨѶ

TYPE

TAGS_CONTROL = packed record
	byLabelType:Byte;	//ǩͣ1 = ISO18000-6B,2 = ISO18000-6C/EPCǩ
	byAntenna:Byte;		//ߺ(Զͨ)
	byLabelID:array[0..7] of Byte;		//ISO18000-6BǩID
	byLabelEPC:array[0..11] of Byte;	//ISO18000-6C/EPCǩEPC
end;

ReadControl = packed record
	TagID:array[0..7] of Char;		//ǩID
	byAddress:Byte;		//ǩַϢ
	byAntenna:Byte;		//ȡǩ
end;

TAGDATA_CONTROL = packed record
	byAntenna:Byte;
	byLabelData:array[0..7] of Byte;
end;

WriteControl = packed record
	TagID:array[0..7] of Char;		//ǩID
	byAddress:Byte;		//дַ
	byValue:array[0..3] of Char;		//дݣһֽ
end;

NET_SETTING = packed record
	byIpValue:array[0..3] of Byte;	//IPַ
	byMarkValue:array[0..3] of Byte;	//
	byGateValue:array[0..3] of Byte;	//ȱʡ
	m_nPort:Integer;		//˿ں
end;

EPC_READ_CONTROL = packed record
	byMembank:Byte;	//ǩڴ
	byWordPtr:Byte;	//ǩڴַ
	byWordCnt:Byte;	//ǩĶȡ
end;

EPC_LABEL_VALUE = packed record
  byKillPWD:array[0..3] of Byte;		//ǩ,4ֽڣ2
	byAccessPWD:array[0..3] of Byte;	//ǩķ룬4ֽڣ2
	byLabelEPC:array[0..11] of Byte;	//ǩEPC룬6ֽڣ12ֽ
	byLabelTID:array[0..7] of Byte;		//ǩTID룬8ֽ
	byMemoData:array[0..15] of Byte;	//ǩû(ֵ֧16ֽڣ8)
end;

EPC_WRITE_CONTROL = packed record
	byMembank:Byte; //ǩڴ
	byWordPtr:Byte; //ǩڴַ
	byWordCnt:Byte; //ǩڴַ
  byKillPWD:array[0..3] of Char;		//ǩ,4ֽڣ2
	byAccessPWD:array[0..3] of Char;	//ǩķ룬4ֽڣ2
	byLabelEPC:array[0..11] of Char;	//ǩEPC룬6ֽڣ12ֽ
	byMemoData:array[0..15] of Char;	//ǩû(ֵ֧16ֽڣ8)
end;

INPUT_LEVEL = packed record         //˿ڵƽ״̬
  byLevel:array[0..7] of Byte;
end;

VAR
  pubTransMode:Integer;     // дӷʽ0-TCPͨѶ1-RS232ͨѶ
  pubHostPort:Integer;      // TCPͨѶ˿ں
  pubHostAddr:String;       // IPַ
  pubSerialNum:String;      // ں
  pubSerialBaud:Integer;    // ڲ
  pubReaderHandle:Integer;  // дӶ˿ھ
  pubReaderAddr:Byte;       // д豸ַ485ͨѶ
  pubConnectOK:Boolean;     // дǷɹ
{************************************************
	ܣ	ʼ豸˿ںREADER,豸òдļ
		hPort:PCREADERЧ˿ھ
          nTransMode:ͨѶʽ0-ͨѶ1-ͨѶ
          strReaderIP:READERIPַ
          strSerialNum:ͨѶʽReaderӵPCCOM1~COMn
          nCommBaud:ͨѶʽReaderӵPCڲʣ19200bps57600bps
	Ϣμ"APIϢ궨"
*************************************************}
function ConnectReader(Var
     hPort:Integer;
     nTransMode:Integer;
     nNetPort:Integer;
     strReaderIP:String;
     strSerialNum:String;nCommBaud:Integer):Word; Stdcall;external 'Mr915ApiV20.dll' name 'ConnectReader';

{************************************************
	ܣ	ر豸˿ڣϿ豸
		hPort-Ѿ򿪵Ķ˿ھ
	Ϣμ"APIϢ궨"
*************************************************}
function Disconnect (hPort:Integer):Word; Stdcall;external 'Mr915ApiV20.dll' name 'Disconnect';

{************************************************
	ܣ	öдĲ
		hPort-Ѿ򿪵Ķ˿ھ
	Ϣμ"APIϢ궨"
*************************************************}
function SetBaudRate(hPort:Integer;usBaudRate:Integer;byReaderAddr:Byte):Word; Stdcall;external 'Mr915ApiV20.dll' name 'SetBaudRate';

{************************************************
	ܣ	дλ
		hPort-Ѿ򿪵Ķ˿ھ
	Ϣμ"APIϢ궨"
*************************************************}
function ResetReader (hPort:Integer;byReaderAddr:Byte):Word; Stdcall;external 'Mr915ApiV20.dll' name 'ResetReader';

{************************************************
	ܣ	ȡд̼汾
		hPort-Ѿ򿪵Ķ˿ھ
	Ϣμ"APIϢ궨"
*************************************************}
function GetFirmwareVersion (hPort:Integer;
                            var byMajor:Byte;
                            var byMinor:Byte;
                            byReaderAddr:Byte):Word; Stdcall;external 'Mr915ApiV20.dll' name 'GetFirmwareVersion';

{************************************************
	ܣöдĹʺƵʲ
	μûֲ
	Ϣμ"APIϢ궨"
*************************************************}
function SetRf (hPort:Integer;
                byPower:Byte;
                byFreqType:Byte;
                byReaderAddr:Byte):Word; Stdcall;external 'Mr915ApiV20.dll' name 'SetRf';

{************************************************
	ܣȡдĵǰƵ
	μûֲ
	Ϣμ"APIϢ궨"
*************************************************}
function GetRf (hPort:Integer;
                var byPower:Byte;
                var byFreqType:Byte;
                byReaderAddr:Byte):Word; Stdcall;external 'Mr915ApiV20.dll' name 'GetRf';

{************************************************
	ܣ߲
	μûֲ
	Ϣμ"APIϢ궨"
*************************************************}
function SetAntenna (hPort:Integer;
                byAntenna:Byte;
                byReaderAddr:Byte):Word; Stdcall;external 'Mr915ApiV20.dll' name 'SetAntenna';

{************************************************
	ܣȡдĵǰ߲
	μûֲ
	Ϣμ"APIϢ궨"
*************************************************}
function GetAntenna (hPort:Integer;
                var byAntenna:Byte;
                byReaderAddr:Byte):Word; Stdcall;external 'Mr915ApiV20.dll' name 'GetAntenna';

/////////// ISO18000-6Bǩ
{************************************************
	ܣISO18000-6Bǩʶ𡣰ظݹˣµһֶǩʶǰʹClearIDBufferдڲա
	μûֲ
	Ϣμ"APIϢ궨"
*************************************************}
function IsoMultiTagIdentify(hPort:Integer;
                      byReaderAddr:Byte;
                      var nCount:Integer;
                      var taTags:array of TAGS_CONTROL):Word; Stdcall;external 'Mr915ApiV20.dll' name 'IsoMultiTagIdentify';

{************************************************
	ܣȡָIDŵıǩݣÿζȡַָʼ8ֽ
	μûֲ
	Ϣμ"APIϢ궨"
*************************************************}
function IsoReadWithID(hPort:Integer;
                      ReadCtrl:ReadControl;
                      var tdData:TAGDATA_CONTROL;
                      byReaderAddr:Byte):Word; Stdcall;external 'Mr915ApiV20.dll' name 'IsoReadWithID';

{************************************************
	ܣָIDŵıǩд
	μûֲ
	Ϣμ"APIϢ궨"
*************************************************}
function IsoWriteWithID(hPort:Integer;
                      WriteCtrl:WriteControl;
                      byReaderAddr:Byte):Word; Stdcall;external 'Mr915ApiV20.dll' name 'IsoWriteWithID';

{************************************************
	ܣַָд4ֽݡ
	μûֲ
	Ϣμ"APIϢ궨"
*************************************************}
function IsoBlockWrite(hPort:Integer;
                      WriteCtrl:WriteControl;
                      byReaderAddr:Byte):Word; Stdcall;external 'Mr915ApiV20.dll' name 'IsoBlockWrite';

{************************************************
	ܣָıǩַдһõַܱ
	μûֲ
	Ϣμ"APIϢ궨"
*************************************************}
function IsoLockTag(hPort:Integer;
                      byRomAddr:Byte;
                      byReaderAddr:Byte):Word; Stdcall;external 'Mr915ApiV20.dll' name 'IsoLockTag';

{************************************************
	ܣѯַָǷд
	μûֲ
	Ϣμ"APIϢ궨"
*************************************************}
function IsoQueryLock(hPort:Integer;
                      byRomAddr:Byte;
                      var byIsLocked:Byte;
                      byReaderAddr:Byte):Word; Stdcall;external 'Mr915ApiV20.dll' name 'IsoQueryLock';

////////////////////// EPC GEN2 ǩ
{************************************************
	ܣEPC GEN2 ǩʶ,ظݹ
	μûֲ
	Ϣμ"APIϢ궨"
*************************************************}
function Gen2MultiTagIdentify(hPort:Integer;
                      byReaderAddr:Byte;
                      var nCount:Integer;
                      var taTags:array of TAGS_CONTROL):Word; Stdcall;external 'Mr915ApiV20.dll' name 'Gen2MultiTagIdentify';

{************************************************
	ܣEPC GEN2 ǩEPCд,ÿд1֣2ֽڣ
	μûֲ
	Ϣμ"APIϢ궨"
*************************************************}
function Gen2WriteEPC(hPort:Integer;
                      byWriteCtrl:EPC_WRITE_CONTROL;
                      byReaderAddr:Byte):Word; Stdcall;external 'Mr915ApiV20.dll' name 'Gen2WriteEPC';

{************************************************
	ܣEPCǩдÿдһ
	μûֲ
	Ϣμ"APIϢ궨"
*************************************************}
function Gen2LockTag(hPort:Integer;
                      byMemBank:Byte;
                      byReaderAddr:Byte):Word; Stdcall;external 'Mr915ApiV20.dll' name 'Gen2LockTag';

{************************************************
	ܣEPC GEN2ǩ
	μûֲ
	Ϣμ"APIϢ궨"
*************************************************}
function Gen2KillTag(hPort:Integer;
                      PassWord:Integer;
                      byReaderAddr:Byte):Word; Stdcall;external 'Mr915ApiV20.dll' name 'Gen2KillTag';

{************************************************
	ܣʼǩEPCȣĬϳʼΪ96λ6ֵ֣Ϊȫ0
	μûֲ
	Ϣμ"APIϢ궨"
*************************************************}
function Gen2InitEPCSize(hPort:Integer;
                      byWordCount:Byte;
                      byReaderAddr:Byte):Word; Stdcall;external 'Mr915ApiV20.dll' name 'Gen2InitEPCSize';

{************************************************
	ܣȡEPC ǩTID룬бǩTID
	μûֲ
	Ϣμ"APIϢ궨"
*************************************************}
function Gen2ReadBlock(hPort:Integer;
                      epcReadCtrl:EPC_READ_CONTROL;
                      var epcValue:EPC_LABEL_VALUE;
                      byReaderAddr:Byte):Word; Stdcall;external 'Mr915ApiV20.dll' name 'Gen2ReadBlock';

{************************************************
	ܣEPC GEN2 ǩд
	μûֲ
	Ϣμ"APIϢ궨"
*************************************************}
function Gen2BlockWrite(hPort:Integer;
                      epcWriteCtrl:EPC_WRITE_CONTROL;
                      byReaderAddr:Byte):Word; Stdcall;external 'Mr915ApiV20.dll' name 'Gen2BlockWrite';

//////////////// ǩݴ
{************************************************
	ܣնдǩݻÿζǩʶǰʹ
	μûֲ
	Ϣμ"APIϢ궨"
*************************************************}
function ClearIDBuffer(hPort:Integer;
                      byReaderAddr:Byte):Word; Stdcall;external 'Mr915ApiV20.dll' name 'ClearIDBuffer';

{************************************************
	ܣѯбǩ
	μûֲ
	Ϣμ"APIϢ궨"
*************************************************}
function QueryIDCount(hPort:Integer;
                      var byCount:Byte;
                      byReaderAddr:Byte):Word; Stdcall;external 'Mr915ApiV20.dll' name 'QueryIDCount';

{************************************************
	ܣд˿ڵĵƽ״̬
	μûֲ
	Ϣμ"APIϢ궨"
*************************************************}
function GetInput (hPort:Integer;
                var inValue:INPUT_LEVEL;
                byReaderAddr:Byte):Word; Stdcall;external 'Mr915ApiV20.dll' name 'GetInput';
{************************************************
	ܣöд˿ڵĸߵ͵ƽ
	μûֲ
	Ϣμ"APIϢ궨"
*************************************************}
function SetOutPort (hPort:Integer;
                byPortNum:Byte;
                byLevel:Byte;
                byReaderAddr:Byte):Word; Stdcall;external 'Mr915ApiV20.dll' name 'SetOutPort';

{************************************************
	ܣѯдãIPַ롢ȱʡأ
	μûֲ
	Ϣμ"APIϢ궨"
*************************************************}
function GetNetSetting(hPort:Integer;
                      var nsNetSetting:NET_SETTING;
                      byReaderAddr:Byte):Word; Stdcall;external 'Mr915ApiV20.dll' name 'GetNetSetting';

{************************************************
	ܣöдãIPַ롢ȱʡأ
	μûֲ
	Ϣμ"APIϢ궨"
*************************************************}
function SetNetSetting(hPort:Integer;
                      nsNetSetting:NET_SETTING;
                      byReaderAddr:Byte):Word; Stdcall;external 'Mr915ApiV20.dll' name 'SetNetSetting';

{************************************************
	ܣѯдãIPַ롢ȱʡأ
	μûֲ
	Ϣμ"APIϢ궨"
*************************************************}
function GetParameter(hPort:Integer;
                      byType:Byte;
                      var byValue:Byte;
                      byReaderAddr:Byte):Word; Stdcall;external 'Mr915ApiV20.dll' name 'GetParameter';

{************************************************
	ܣöдãIPַ롢ȱʡأ
	μûֲ
	Ϣμ"APIϢ궨"
*************************************************}
function SetParameter(hPort:Integer;
                      byType:Byte;
                      byValue:Byte;
                      byReaderAddr:Byte):Word; Stdcall;external 'Mr915ApiV20.dll' name 'SetParameter';
implementation

end.
